// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_radar_msgs:msg/Object.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT__STRUCT_HPP_
#define OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'a'
#include "off_highway_radar_msgs/msg/detail/object_a__struct.hpp"
// Member 'b'
#include "off_highway_radar_msgs/msg/detail/object_b__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__off_highway_radar_msgs__msg__Object __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_radar_msgs__msg__Object __declspec(deprecated)
#endif

namespace off_highway_radar_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Object_
{
  using Type = Object_<ContainerAllocator>;

  explicit Object_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    a(_init),
    b(_init)
  {
    (void)_init;
  }

  explicit Object_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    a(_alloc, _init),
    b(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _a_type =
    off_highway_radar_msgs::msg::ObjectA_<ContainerAllocator>;
  _a_type a;
  using _b_type =
    off_highway_radar_msgs::msg::ObjectB_<ContainerAllocator>;
  _b_type b;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__a(
    const off_highway_radar_msgs::msg::ObjectA_<ContainerAllocator> & _arg)
  {
    this->a = _arg;
    return *this;
  }
  Type & set__b(
    const off_highway_radar_msgs::msg::ObjectB_<ContainerAllocator> & _arg)
  {
    this->b = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_radar_msgs::msg::Object_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_radar_msgs::msg::Object_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_radar_msgs::msg::Object_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_radar_msgs::msg::Object_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_radar_msgs::msg::Object_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_radar_msgs::msg::Object_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_radar_msgs::msg::Object_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_radar_msgs::msg::Object_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_radar_msgs::msg::Object_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_radar_msgs::msg::Object_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_radar_msgs__msg__Object
    std::shared_ptr<off_highway_radar_msgs::msg::Object_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_radar_msgs__msg__Object
    std::shared_ptr<off_highway_radar_msgs::msg::Object_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Object_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->a != other.a) {
      return false;
    }
    if (this->b != other.b) {
      return false;
    }
    return true;
  }
  bool operator!=(const Object_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Object_

// alias to use template instance with default allocator
using Object =
  off_highway_radar_msgs::msg::Object_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_radar_msgs

#endif  // OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT__STRUCT_HPP_
