// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_radar_msgs:msg/ObjectA.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT_A__STRUCT_HPP_
#define OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT_A__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"
// Member 'position'
#include "geometry_msgs/msg/detail/point__struct.hpp"
// Member 'velocity'
#include "geometry_msgs/msg/detail/twist__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__off_highway_radar_msgs__msg__ObjectA __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_radar_msgs__msg__ObjectA __declspec(deprecated)
#endif

namespace off_highway_radar_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ObjectA_
{
  using Type = ObjectA_<ContainerAllocator>;

  explicit ObjectA_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init),
    position(_init),
    velocity(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_id = 0ul;
      this->id = 0;
      this->meas = false;
      this->valid = false;
      this->hist = false;
    }
  }

  explicit ObjectA_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init),
    position(_alloc, _init),
    velocity(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_id = 0ul;
      this->id = 0;
      this->meas = false;
      this->valid = false;
      this->hist = false;
    }
  }

  // field types and members
  using _can_id_type =
    uint32_t;
  _can_id_type can_id;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;
  using _id_type =
    uint8_t;
  _id_type id;
  using _position_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _position_type position;
  using _velocity_type =
    geometry_msgs::msg::Twist_<ContainerAllocator>;
  _velocity_type velocity;
  using _meas_type =
    bool;
  _meas_type meas;
  using _valid_type =
    bool;
  _valid_type valid;
  using _hist_type =
    bool;
  _hist_type hist;

  // setters for named parameter idiom
  Type & set__can_id(
    const uint32_t & _arg)
  {
    this->can_id = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }
  Type & set__id(
    const uint8_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__position(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->position = _arg;
    return *this;
  }
  Type & set__velocity(
    const geometry_msgs::msg::Twist_<ContainerAllocator> & _arg)
  {
    this->velocity = _arg;
    return *this;
  }
  Type & set__meas(
    const bool & _arg)
  {
    this->meas = _arg;
    return *this;
  }
  Type & set__valid(
    const bool & _arg)
  {
    this->valid = _arg;
    return *this;
  }
  Type & set__hist(
    const bool & _arg)
  {
    this->hist = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_radar_msgs::msg::ObjectA_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_radar_msgs::msg::ObjectA_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_radar_msgs::msg::ObjectA_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_radar_msgs::msg::ObjectA_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_radar_msgs::msg::ObjectA_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_radar_msgs::msg::ObjectA_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_radar_msgs::msg::ObjectA_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_radar_msgs::msg::ObjectA_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_radar_msgs::msg::ObjectA_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_radar_msgs::msg::ObjectA_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_radar_msgs__msg__ObjectA
    std::shared_ptr<off_highway_radar_msgs::msg::ObjectA_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_radar_msgs__msg__ObjectA
    std::shared_ptr<off_highway_radar_msgs::msg::ObjectA_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ObjectA_ & other) const
  {
    if (this->can_id != other.can_id) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->position != other.position) {
      return false;
    }
    if (this->velocity != other.velocity) {
      return false;
    }
    if (this->meas != other.meas) {
      return false;
    }
    if (this->valid != other.valid) {
      return false;
    }
    if (this->hist != other.hist) {
      return false;
    }
    return true;
  }
  bool operator!=(const ObjectA_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ObjectA_

// alias to use template instance with default allocator
using ObjectA =
  off_highway_radar_msgs::msg::ObjectA_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_radar_msgs

#endif  // OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT_A__STRUCT_HPP_
