// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from off_highway_radar_msgs:msg/ObjectB.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT_B__FUNCTIONS_H_
#define OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT_B__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "off_highway_radar_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "off_highway_radar_msgs/msg/detail/object_b__struct.h"

/// Initialize msg/ObjectB message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * off_highway_radar_msgs__msg__ObjectB
 * )) before or use
 * off_highway_radar_msgs__msg__ObjectB__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_radar_msgs
bool
off_highway_radar_msgs__msg__ObjectB__init(off_highway_radar_msgs__msg__ObjectB * msg);

/// Finalize msg/ObjectB message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_radar_msgs
void
off_highway_radar_msgs__msg__ObjectB__fini(off_highway_radar_msgs__msg__ObjectB * msg);

/// Create msg/ObjectB message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * off_highway_radar_msgs__msg__ObjectB__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_radar_msgs
off_highway_radar_msgs__msg__ObjectB *
off_highway_radar_msgs__msg__ObjectB__create();

/// Destroy msg/ObjectB message.
/**
 * It calls
 * off_highway_radar_msgs__msg__ObjectB__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_radar_msgs
void
off_highway_radar_msgs__msg__ObjectB__destroy(off_highway_radar_msgs__msg__ObjectB * msg);

/// Check for msg/ObjectB message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_radar_msgs
bool
off_highway_radar_msgs__msg__ObjectB__are_equal(const off_highway_radar_msgs__msg__ObjectB * lhs, const off_highway_radar_msgs__msg__ObjectB * rhs);

/// Copy a msg/ObjectB message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_radar_msgs
bool
off_highway_radar_msgs__msg__ObjectB__copy(
  const off_highway_radar_msgs__msg__ObjectB * input,
  off_highway_radar_msgs__msg__ObjectB * output);

/// Initialize array of msg/ObjectB messages.
/**
 * It allocates the memory for the number of elements and calls
 * off_highway_radar_msgs__msg__ObjectB__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_radar_msgs
bool
off_highway_radar_msgs__msg__ObjectB__Sequence__init(off_highway_radar_msgs__msg__ObjectB__Sequence * array, size_t size);

/// Finalize array of msg/ObjectB messages.
/**
 * It calls
 * off_highway_radar_msgs__msg__ObjectB__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_radar_msgs
void
off_highway_radar_msgs__msg__ObjectB__Sequence__fini(off_highway_radar_msgs__msg__ObjectB__Sequence * array);

/// Create array of msg/ObjectB messages.
/**
 * It allocates the memory for the array and calls
 * off_highway_radar_msgs__msg__ObjectB__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_radar_msgs
off_highway_radar_msgs__msg__ObjectB__Sequence *
off_highway_radar_msgs__msg__ObjectB__Sequence__create(size_t size);

/// Destroy array of msg/ObjectB messages.
/**
 * It calls
 * off_highway_radar_msgs__msg__ObjectB__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_radar_msgs
void
off_highway_radar_msgs__msg__ObjectB__Sequence__destroy(off_highway_radar_msgs__msg__ObjectB__Sequence * array);

/// Check for msg/ObjectB message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_radar_msgs
bool
off_highway_radar_msgs__msg__ObjectB__Sequence__are_equal(const off_highway_radar_msgs__msg__ObjectB__Sequence * lhs, const off_highway_radar_msgs__msg__ObjectB__Sequence * rhs);

/// Copy an array of msg/ObjectB messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_radar_msgs
bool
off_highway_radar_msgs__msg__ObjectB__Sequence__copy(
  const off_highway_radar_msgs__msg__ObjectB__Sequence * input,
  off_highway_radar_msgs__msg__ObjectB__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT_B__FUNCTIONS_H_
