// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_radar_msgs:msg/ObjectB.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT_B__STRUCT_HPP_
#define OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT_B__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__off_highway_radar_msgs__msg__ObjectB __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_radar_msgs__msg__ObjectB __declspec(deprecated)
#endif

namespace off_highway_radar_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ObjectB_
{
  using Type = ObjectB_<ContainerAllocator>;

  explicit ObjectB_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_id = 0ul;
      this->id = 0;
      this->time_since_meas = 0.0;
      this->zone = 0;
      this->rcs = 0.0;
      this->moving = false;
      this->near = false;
      this->exist_probability = 0.0;
    }
  }

  explicit ObjectB_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_id = 0ul;
      this->id = 0;
      this->time_since_meas = 0.0;
      this->zone = 0;
      this->rcs = 0.0;
      this->moving = false;
      this->near = false;
      this->exist_probability = 0.0;
    }
  }

  // field types and members
  using _can_id_type =
    uint32_t;
  _can_id_type can_id;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;
  using _id_type =
    uint8_t;
  _id_type id;
  using _time_since_meas_type =
    double;
  _time_since_meas_type time_since_meas;
  using _zone_type =
    uint8_t;
  _zone_type zone;
  using _rcs_type =
    double;
  _rcs_type rcs;
  using _moving_type =
    bool;
  _moving_type moving;
  using _near_type =
    bool;
  _near_type near;
  using _exist_probability_type =
    double;
  _exist_probability_type exist_probability;

  // setters for named parameter idiom
  Type & set__can_id(
    const uint32_t & _arg)
  {
    this->can_id = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }
  Type & set__id(
    const uint8_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__time_since_meas(
    const double & _arg)
  {
    this->time_since_meas = _arg;
    return *this;
  }
  Type & set__zone(
    const uint8_t & _arg)
  {
    this->zone = _arg;
    return *this;
  }
  Type & set__rcs(
    const double & _arg)
  {
    this->rcs = _arg;
    return *this;
  }
  Type & set__moving(
    const bool & _arg)
  {
    this->moving = _arg;
    return *this;
  }
  Type & set__near(
    const bool & _arg)
  {
    this->near = _arg;
    return *this;
  }
  Type & set__exist_probability(
    const double & _arg)
  {
    this->exist_probability = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_radar_msgs::msg::ObjectB_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_radar_msgs::msg::ObjectB_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_radar_msgs::msg::ObjectB_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_radar_msgs::msg::ObjectB_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_radar_msgs::msg::ObjectB_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_radar_msgs::msg::ObjectB_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_radar_msgs::msg::ObjectB_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_radar_msgs::msg::ObjectB_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_radar_msgs::msg::ObjectB_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_radar_msgs::msg::ObjectB_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_radar_msgs__msg__ObjectB
    std::shared_ptr<off_highway_radar_msgs::msg::ObjectB_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_radar_msgs__msg__ObjectB
    std::shared_ptr<off_highway_radar_msgs::msg::ObjectB_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ObjectB_ & other) const
  {
    if (this->can_id != other.can_id) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->time_since_meas != other.time_since_meas) {
      return false;
    }
    if (this->zone != other.zone) {
      return false;
    }
    if (this->rcs != other.rcs) {
      return false;
    }
    if (this->moving != other.moving) {
      return false;
    }
    if (this->near != other.near) {
      return false;
    }
    if (this->exist_probability != other.exist_probability) {
      return false;
    }
    return true;
  }
  bool operator!=(const ObjectB_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ObjectB_

// alias to use template instance with default allocator
using ObjectB =
  off_highway_radar_msgs::msg::ObjectB_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_radar_msgs

#endif  // OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT_B__STRUCT_HPP_
