// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_radar_msgs:msg/Information.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__INFORMATION__STRUCT_HPP_
#define OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__INFORMATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__off_highway_radar_msgs__msg__Information __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_radar_msgs__msg__Information __declspec(deprecated)
#endif

namespace off_highway_radar_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Information_
{
  using Type = Information_<ContainerAllocator>;

  explicit Information_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->sensor_type = 0;
      this->hw_temperature = 0.0;
      this->sensor_blind = false;
      this->sw_fail = false;
      this->hw_fail = false;
      this->can_fail = false;
      this->config_fail = false;
      this->diag_mode = false;
      this->dtc = 0ul;
      this->dtc_order_id = 0;
      this->sensor_not_safe = false;
      this->reception_error = false;
    }
  }

  explicit Information_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->sensor_type = 0;
      this->hw_temperature = 0.0;
      this->sensor_blind = false;
      this->sw_fail = false;
      this->hw_fail = false;
      this->can_fail = false;
      this->config_fail = false;
      this->diag_mode = false;
      this->dtc = 0ul;
      this->dtc_order_id = 0;
      this->sensor_not_safe = false;
      this->reception_error = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _sensor_type_type =
    uint8_t;
  _sensor_type_type sensor_type;
  using _hw_temperature_type =
    double;
  _hw_temperature_type hw_temperature;
  using _sensor_blind_type =
    bool;
  _sensor_blind_type sensor_blind;
  using _sw_fail_type =
    bool;
  _sw_fail_type sw_fail;
  using _hw_fail_type =
    bool;
  _hw_fail_type hw_fail;
  using _can_fail_type =
    bool;
  _can_fail_type can_fail;
  using _config_fail_type =
    bool;
  _config_fail_type config_fail;
  using _diag_mode_type =
    bool;
  _diag_mode_type diag_mode;
  using _dtc_type =
    uint32_t;
  _dtc_type dtc;
  using _dtc_order_id_type =
    uint8_t;
  _dtc_order_id_type dtc_order_id;
  using _sensor_not_safe_type =
    bool;
  _sensor_not_safe_type sensor_not_safe;
  using _reception_error_type =
    bool;
  _reception_error_type reception_error;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__sensor_type(
    const uint8_t & _arg)
  {
    this->sensor_type = _arg;
    return *this;
  }
  Type & set__hw_temperature(
    const double & _arg)
  {
    this->hw_temperature = _arg;
    return *this;
  }
  Type & set__sensor_blind(
    const bool & _arg)
  {
    this->sensor_blind = _arg;
    return *this;
  }
  Type & set__sw_fail(
    const bool & _arg)
  {
    this->sw_fail = _arg;
    return *this;
  }
  Type & set__hw_fail(
    const bool & _arg)
  {
    this->hw_fail = _arg;
    return *this;
  }
  Type & set__can_fail(
    const bool & _arg)
  {
    this->can_fail = _arg;
    return *this;
  }
  Type & set__config_fail(
    const bool & _arg)
  {
    this->config_fail = _arg;
    return *this;
  }
  Type & set__diag_mode(
    const bool & _arg)
  {
    this->diag_mode = _arg;
    return *this;
  }
  Type & set__dtc(
    const uint32_t & _arg)
  {
    this->dtc = _arg;
    return *this;
  }
  Type & set__dtc_order_id(
    const uint8_t & _arg)
  {
    this->dtc_order_id = _arg;
    return *this;
  }
  Type & set__sensor_not_safe(
    const bool & _arg)
  {
    this->sensor_not_safe = _arg;
    return *this;
  }
  Type & set__reception_error(
    const bool & _arg)
  {
    this->reception_error = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_radar_msgs::msg::Information_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_radar_msgs::msg::Information_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_radar_msgs::msg::Information_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_radar_msgs::msg::Information_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_radar_msgs::msg::Information_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_radar_msgs::msg::Information_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_radar_msgs::msg::Information_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_radar_msgs::msg::Information_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_radar_msgs::msg::Information_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_radar_msgs::msg::Information_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_radar_msgs__msg__Information
    std::shared_ptr<off_highway_radar_msgs::msg::Information_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_radar_msgs__msg__Information
    std::shared_ptr<off_highway_radar_msgs::msg::Information_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Information_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->sensor_type != other.sensor_type) {
      return false;
    }
    if (this->hw_temperature != other.hw_temperature) {
      return false;
    }
    if (this->sensor_blind != other.sensor_blind) {
      return false;
    }
    if (this->sw_fail != other.sw_fail) {
      return false;
    }
    if (this->hw_fail != other.hw_fail) {
      return false;
    }
    if (this->can_fail != other.can_fail) {
      return false;
    }
    if (this->config_fail != other.config_fail) {
      return false;
    }
    if (this->diag_mode != other.diag_mode) {
      return false;
    }
    if (this->dtc != other.dtc) {
      return false;
    }
    if (this->dtc_order_id != other.dtc_order_id) {
      return false;
    }
    if (this->sensor_not_safe != other.sensor_not_safe) {
      return false;
    }
    if (this->reception_error != other.reception_error) {
      return false;
    }
    return true;
  }
  bool operator!=(const Information_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Information_

// alias to use template instance with default allocator
using Information =
  off_highway_radar_msgs::msg::Information_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_radar_msgs

#endif  // OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__INFORMATION__STRUCT_HPP_
